Index: branches/HiveProjectManagement/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ProjectView.cs
===================================================================
--- branches/HiveProjectManagement/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ProjectView.cs	(revision 15401)
+++ branches/HiveProjectManagement/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ProjectView.cs	(revision 15401)
@@ -0,0 +1,195 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2017 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.ComponentModel;
+using System.Linq;
+using System.Windows.Forms;
+using HeuristicLab.Clients.Access;
+using HeuristicLab.Core.Views;
+using HeuristicLab.MainForm;
+using Tasks = System.Threading.Tasks;
+
+namespace HeuristicLab.Clients.Hive.Administrator.Views {
+  [View("ProjectView")]
+  [Content(typeof(Project), IsDefaultView = true)]
+  public partial class ProjectView : ItemView {
+    private readonly object locker = new object();
+    private bool updatingUsers = false;
+
+    public new Project Content {
+      get { return (Project)base.Content; }
+      set { base.Content = value; }
+    }
+
+    public ProjectView() {
+      InitializeComponent();
+
+      AccessClient.Instance.Refreshing += AccessClient_Instance_Refreshing;
+      AccessClient.Instance.Refreshed += AccessClient_Instance_Refreshed;
+    }
+
+    protected override void OnClosing(FormClosingEventArgs e) {
+      AccessClient.Instance.Refreshed -= AccessClient_Instance_Refreshed;
+      AccessClient.Instance.Refreshing -= AccessClient_Instance_Refreshing;
+      base.OnClosing(e);
+    }
+
+    protected override void RegisterContentEvents() {
+      base.RegisterContentEvents();
+      Content.PropertyChanged += Content_PropertyChanged;
+    }
+
+    protected override void DeregisterContentEvents() {
+      Content.PropertyChanged -= Content_PropertyChanged;
+      base.DeregisterContentEvents();
+    }
+
+    private void Content_PropertyChanged(object sender, PropertyChangedEventArgs e) {
+      OnContentChanged();
+    }
+
+    protected override void OnContentChanged() {
+      base.OnContentChanged();
+      if (Content == null) {
+        nameTextBox.Clear();
+        descriptionTextBox.Clear();
+        ownerComboBox.DataSource = null;
+        ownerComboBox.SelectedItem = null;
+        createdTextBox.Clear();
+        startDateTimePicker.Value = DateTime.Now;
+        endDateTimePicker.Value = startDateTimePicker.Value;
+        indefiniteCheckBox.Checked = false;
+      } else {
+        nameTextBox.Text = Content.Name;
+        descriptionTextBox.Text = Content.Description;
+        ownerComboBox.DataSource = AccessClient.Instance.UsersAndGroups.OfType<LightweightUser>().ToList();
+        ownerComboBox.SelectedItem = AccessClient.Instance.UsersAndGroups.FirstOrDefault(x => x.Id == Content.OwnerUserId);
+        createdTextBox.Text = Content.DateCreated.ToString("ddd, dd.MM.yyyy, HH:mm:ss");
+        startDateTimePicker.Value = Content.StartDate;
+        if (indefiniteCheckBox.Checked = !Content.EndDate.HasValue) {
+          endDateTimePicker.Value = startDateTimePicker.Value;
+        } else {
+          endDateTimePicker.Value = Content.EndDate.Value;
+        }
+      }
+    }
+
+    protected override void SetEnabledStateOfControls() {
+      base.SetEnabledStateOfControls();
+      bool enabled = Content != null;
+      nameTextBox.Enabled = enabled;
+      descriptionTextBox.Enabled = enabled;
+      ownerComboBox.Enabled = enabled;
+      createdTextBox.Enabled = enabled;
+      startDateTimePicker.Enabled = enabled;
+      endDateTimePicker.Enabled = enabled && Content.EndDate.HasValue;
+      indefiniteCheckBox.Enabled = enabled;
+    }
+
+    private void AccessClient_Instance_Refreshing(object sender, EventArgs e) {
+      if (InvokeRequired) Invoke((Action<object, EventArgs>)AccessClient_Instance_Refreshing, sender, e);
+      else {
+        var mainForm = MainFormManager.GetMainForm<MainForm.WindowsForms.MainForm>();
+        mainForm.AddOperationProgressToView(this, "Refreshing ...");
+        SetEnabledStateOfControls();
+      }
+    }
+
+    private void AccessClient_Instance_Refreshed(object sender, EventArgs e) {
+      if (InvokeRequired) Invoke((Action<object, EventArgs>)AccessClient_Instance_Refreshed, sender, e);
+      else {
+        var mainForm = MainFormManager.GetMainForm<MainForm.WindowsForms.MainForm>();
+        mainForm.RemoveOperationProgressFromView(this);
+        SetEnabledStateOfControls();
+      }
+    }
+
+    private async void ProjectView_Load(object sender, EventArgs e) {
+      lock (locker) {
+        if (updatingUsers) return;
+        updatingUsers = true;
+      }
+      try {
+        await Tasks.Task.Run(() => UpdateUsers());
+      } finally {
+        updatingUsers = false;
+      }
+    }
+
+    private async void refreshButton_Click(object sender, EventArgs e) {
+      lock (locker) {
+        if (updatingUsers) return;
+        updatingUsers = true;
+      }
+      try {
+        await Tasks.Task.Run(() => UpdateUsers());
+      } finally {
+        updatingUsers = false;
+      }
+    }
+
+    private void UpdateUsers() {
+      ownerComboBox.DataSource = null;
+      AccessClient.Instance.Refresh();
+      if (Content != null) {
+        ownerComboBox.DataSource = AccessClient.Instance.UsersAndGroups.OfType<LightweightUser>().ToList();
+        ownerComboBox.SelectedItem = AccessClient.Instance.UsersAndGroups.FirstOrDefault(x => x.Id == Content.OwnerUserId);
+      }
+    }
+
+    private void nameTextBox_Validating(object sender, CancelEventArgs e) {
+      if (string.IsNullOrEmpty(nameTextBox.Text)) {
+        MessageBox.Show(
+          "Project must have a name.",
+          "HeuristicLab Hive Administrator",
+          MessageBoxButtons.OK,
+          MessageBoxIcon.Error);
+        e.Cancel = true;
+      } else Content.Name = nameTextBox.Text;
+    }
+
+    private void descriptionTextBox_Validating(object sender, CancelEventArgs e) {
+      Content.Description = descriptionTextBox.Text;
+    }
+
+    private void ownerComboBox_SelectedIndexChanged(object sender, EventArgs e) {
+      var selectedItem = (LightweightUser)ownerComboBox.SelectedItem;
+      Content.OwnerUserId = selectedItem != null ? selectedItem.Id : Guid.Empty;
+    }
+
+    private void startDateTimePicker_Validating(object sender, CancelEventArgs e) {
+      if (!Content.EndDate.HasValue || startDateTimePicker.Value > Content.EndDate)
+        endDateTimePicker.Value = startDateTimePicker.Value;
+      Content.StartDate = startDateTimePicker.Value;
+    }
+
+    private void endDateTimePicker_Validating(object sender, CancelEventArgs e) {
+      if (endDateTimePicker.Value < startDateTimePicker.Value)
+        endDateTimePicker.Value = startDateTimePicker.Value;
+      Content.EndDate = endDateTimePicker.Value;
+    }
+
+    private void indefiniteCheckBox_CheckedChanged(object sender, EventArgs e) {
+      Content.EndDate = indefiniteCheckBox.Checked ? (DateTime?)null : Content.StartDate;
+    }
+  }
+}
Index: branches/HiveProjectManagement/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ProjectsView.Designer.cs
===================================================================
--- branches/HiveProjectManagement/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ProjectsView.Designer.cs	(revision 15401)
+++ branches/HiveProjectManagement/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ProjectsView.Designer.cs	(revision 15401)
@@ -0,0 +1,248 @@
+﻿namespace HeuristicLab.Clients.Hive.Administrator.Views {
+  partial class ProjectsView {
+    /// <summary> 
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary> 
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing && (components != null)) {
+        components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Component Designer generated code
+
+    /// <summary> 
+    /// Required method for Designer support - do not modify 
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      this.components = new System.ComponentModel.Container();
+      this.splitContainer = new System.Windows.Forms.SplitContainer();
+      this.refreshButton = new System.Windows.Forms.Button();
+      this.saveProjectButton = new System.Windows.Forms.Button();
+      this.removeButton = new System.Windows.Forms.Button();
+      this.addButton = new System.Windows.Forms.Button();
+      this.projectsTreeView = new System.Windows.Forms.TreeView();
+      this.imageList = new System.Windows.Forms.ImageList(this.components);
+      this.tabControl = new System.Windows.Forms.TabControl();
+      this.detailsTabPage = new System.Windows.Forms.TabPage();
+      this.projectView = new HeuristicLab.Clients.Hive.Administrator.Views.ProjectView();
+      this.permissionsTabPage = new System.Windows.Forms.TabPage();
+      this.savePermissionsButton = new System.Windows.Forms.Button();
+      this.permissionsView = new HeuristicLab.Clients.Access.Views.RefreshableLightweightUserView();
+      ((System.ComponentModel.ISupportInitialize)(this.splitContainer)).BeginInit();
+      this.splitContainer.Panel1.SuspendLayout();
+      this.splitContainer.Panel2.SuspendLayout();
+      this.splitContainer.SuspendLayout();
+      this.tabControl.SuspendLayout();
+      this.detailsTabPage.SuspendLayout();
+      this.permissionsTabPage.SuspendLayout();
+      this.SuspendLayout();
+      // 
+      // splitContainer
+      // 
+      this.splitContainer.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
+            | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.splitContainer.Location = new System.Drawing.Point(3, 3);
+      this.splitContainer.Name = "splitContainer";
+      // 
+      // splitContainer.Panel1
+      // 
+      this.splitContainer.Panel1.Controls.Add(this.refreshButton);
+      this.splitContainer.Panel1.Controls.Add(this.saveProjectButton);
+      this.splitContainer.Panel1.Controls.Add(this.removeButton);
+      this.splitContainer.Panel1.Controls.Add(this.addButton);
+      this.splitContainer.Panel1.Controls.Add(this.projectsTreeView);
+      // 
+      // splitContainer.Panel2
+      // 
+      this.splitContainer.Panel2.Controls.Add(this.tabControl);
+      this.splitContainer.Size = new System.Drawing.Size(847, 547);
+      this.splitContainer.SplitterDistance = 249;
+      this.splitContainer.TabIndex = 0;
+      // 
+      // refreshButton
+      // 
+      this.refreshButton.Image = HeuristicLab.Common.Resources.VSImageLibrary.Refresh;
+      this.refreshButton.Location = new System.Drawing.Point(3, 3);
+      this.refreshButton.Name = "refreshButton";
+      this.refreshButton.Size = new System.Drawing.Size(24, 24);
+      this.refreshButton.TabIndex = 14;
+      this.refreshButton.UseVisualStyleBackColor = true;
+      this.refreshButton.Click += new System.EventHandler(this.refreshButton_Click);
+      // 
+      // saveProjectButton
+      // 
+      this.saveProjectButton.Image = HeuristicLab.Common.Resources.VSImageLibrary.PublishToWeb;
+      this.saveProjectButton.Location = new System.Drawing.Point(93, 3);
+      this.saveProjectButton.Name = "saveProjectButton";
+      this.saveProjectButton.Size = new System.Drawing.Size(24, 24);
+      this.saveProjectButton.TabIndex = 12;
+      this.saveProjectButton.UseVisualStyleBackColor = true;
+      this.saveProjectButton.Click += new System.EventHandler(this.saveProjectButton_Click);
+      // 
+      // removeButton
+      // 
+      this.removeButton.Image = HeuristicLab.Common.Resources.VSImageLibrary.Remove;
+      this.removeButton.Location = new System.Drawing.Point(63, 3);
+      this.removeButton.Name = "removeButton";
+      this.removeButton.Size = new System.Drawing.Size(24, 24);
+      this.removeButton.TabIndex = 11;
+      this.removeButton.UseVisualStyleBackColor = true;
+      this.removeButton.Click += new System.EventHandler(this.removeButton_Click);
+      // 
+      // addButton
+      // 
+      this.addButton.Image = HeuristicLab.Common.Resources.VSImageLibrary.Add;
+      this.addButton.Location = new System.Drawing.Point(33, 3);
+      this.addButton.Name = "addButton";
+      this.addButton.Size = new System.Drawing.Size(24, 24);
+      this.addButton.TabIndex = 10;
+      this.addButton.UseVisualStyleBackColor = true;
+      this.addButton.Click += new System.EventHandler(this.addButton_Click);
+      // 
+      // projectsTreeView
+      // 
+      this.projectsTreeView.AllowDrop = true;
+      this.projectsTreeView.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
+            | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.projectsTreeView.ImageIndex = 0;
+      this.projectsTreeView.ImageList = this.imageList;
+      this.projectsTreeView.Location = new System.Drawing.Point(3, 33);
+      this.projectsTreeView.Name = "projectsTreeView";
+      this.projectsTreeView.SelectedImageIndex = 0;
+      this.projectsTreeView.Size = new System.Drawing.Size(243, 511);
+      this.projectsTreeView.TabIndex = 9;
+      this.projectsTreeView.ItemDrag += new System.Windows.Forms.ItemDragEventHandler(this.projectsTreeView_ItemDrag);
+      this.projectsTreeView.AfterSelect += new System.Windows.Forms.TreeViewEventHandler(this.projectsTreeView_AfterSelect);
+      this.projectsTreeView.DragDrop += new System.Windows.Forms.DragEventHandler(this.projectsTreeView_DragDrop);
+      this.projectsTreeView.DragEnter += new System.Windows.Forms.DragEventHandler(this.projectsTreeView_DragEnter);
+      this.projectsTreeView.DragOver += new System.Windows.Forms.DragEventHandler(this.projectsTreeView_DragOver);
+      this.projectsTreeView.QueryContinueDrag += new System.Windows.Forms.QueryContinueDragEventHandler(this.projectsTreeView_QueryContinueDrag);
+      // 
+      // imageList
+      // 
+      this.imageList.ColorDepth = System.Windows.Forms.ColorDepth.Depth8Bit;
+      this.imageList.ImageSize = new System.Drawing.Size(16, 16);
+      this.imageList.TransparentColor = System.Drawing.Color.Transparent;
+      // 
+      // tabControl
+      // 
+      this.tabControl.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
+            | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.tabControl.Controls.Add(this.detailsTabPage);
+      this.tabControl.Controls.Add(this.permissionsTabPage);
+      this.tabControl.Location = new System.Drawing.Point(3, 3);
+      this.tabControl.Name = "tabControl";
+      this.tabControl.SelectedIndex = 0;
+      this.tabControl.Size = new System.Drawing.Size(585, 541);
+      this.tabControl.TabIndex = 0;
+      this.tabControl.SelectedIndexChanged += new System.EventHandler(this.tabControl_SelectedIndexChanged);
+      // 
+      // detailsTabPage
+      // 
+      this.detailsTabPage.Controls.Add(this.projectView);
+      this.detailsTabPage.Location = new System.Drawing.Point(4, 22);
+      this.detailsTabPage.Name = "detailsTabPage";
+      this.detailsTabPage.Padding = new System.Windows.Forms.Padding(3);
+      this.detailsTabPage.Size = new System.Drawing.Size(577, 515);
+      this.detailsTabPage.TabIndex = 0;
+      this.detailsTabPage.Text = "Details";
+      this.detailsTabPage.UseVisualStyleBackColor = true;
+      // 
+      // projectView
+      // 
+      this.projectView.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
+            | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.projectView.Caption = "ProjectView";
+      this.projectView.Content = null;
+      this.projectView.Location = new System.Drawing.Point(6, 6);
+      this.projectView.Name = "projectView";
+      this.projectView.ReadOnly = false;
+      this.projectView.Size = new System.Drawing.Size(565, 503);
+      this.projectView.TabIndex = 0;
+      // 
+      // permissionsTabPage
+      // 
+      this.permissionsTabPage.Controls.Add(this.savePermissionsButton);
+      this.permissionsTabPage.Controls.Add(this.permissionsView);
+      this.permissionsTabPage.Location = new System.Drawing.Point(4, 22);
+      this.permissionsTabPage.Name = "permissionsTabPage";
+      this.permissionsTabPage.Padding = new System.Windows.Forms.Padding(3);
+      this.permissionsTabPage.Size = new System.Drawing.Size(577, 515);
+      this.permissionsTabPage.TabIndex = 1;
+      this.permissionsTabPage.Text = "Permissions";
+      this.permissionsTabPage.UseVisualStyleBackColor = true;
+      // 
+      // savePermissionsButton
+      // 
+      this.savePermissionsButton.Enabled = false;
+      this.savePermissionsButton.Image = HeuristicLab.Common.Resources.VSImageLibrary.PublishToWeb;
+      this.savePermissionsButton.Location = new System.Drawing.Point(39, 9);
+      this.savePermissionsButton.Name = "savePermissionsButton";
+      this.savePermissionsButton.Size = new System.Drawing.Size(24, 24);
+      this.savePermissionsButton.TabIndex = 2;
+      this.savePermissionsButton.UseVisualStyleBackColor = true;
+      this.savePermissionsButton.Click += new System.EventHandler(this.savePermissionsButton_Click);
+      // 
+      // permissionsView
+      // 
+      this.permissionsView.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
+            | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.permissionsView.Caption = "RefreshableLightweightUser View";
+      this.permissionsView.Content = null;
+      this.permissionsView.FetchSelectedUsers = null;
+      this.permissionsView.Location = new System.Drawing.Point(6, 6);
+      this.permissionsView.Name = "permissionsView";
+      this.permissionsView.ReadOnly = false;
+      this.permissionsView.Size = new System.Drawing.Size(565, 503);
+      this.permissionsView.TabIndex = 0;
+      // 
+      // ProjectsView
+      // 
+      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.Controls.Add(this.splitContainer);
+      this.Name = "ProjectsView";
+      this.Size = new System.Drawing.Size(853, 553);
+      this.Load += new System.EventHandler(this.ProjectsView_Load);
+      this.splitContainer.Panel1.ResumeLayout(false);
+      this.splitContainer.Panel2.ResumeLayout(false);
+      ((System.ComponentModel.ISupportInitialize)(this.splitContainer)).EndInit();
+      this.splitContainer.ResumeLayout(false);
+      this.tabControl.ResumeLayout(false);
+      this.detailsTabPage.ResumeLayout(false);
+      this.permissionsTabPage.ResumeLayout(false);
+      this.ResumeLayout(false);
+
+    }
+
+    #endregion
+
+    private System.Windows.Forms.SplitContainer splitContainer;
+    private System.Windows.Forms.Button refreshButton;
+    private System.Windows.Forms.Button saveProjectButton;
+    private System.Windows.Forms.Button removeButton;
+    private System.Windows.Forms.Button addButton;
+    private System.Windows.Forms.TreeView projectsTreeView;
+    private System.Windows.Forms.TabControl tabControl;
+    private System.Windows.Forms.TabPage detailsTabPage;
+    private System.Windows.Forms.TabPage permissionsTabPage;
+    private ProjectView projectView;
+    private System.Windows.Forms.ImageList imageList;
+    private Access.Views.RefreshableLightweightUserView permissionsView;
+    private System.Windows.Forms.Button savePermissionsButton;
+  }
+}
